#include <stdio.h>
#include <stdlib.h>
#include "pilha.h"

/*------------------------------------------------------------------*/
static int tamanho(pilha p) {
  return p.ultimo - p.primeiro + 1;
}

/*------------------------------------------------------------------*/
static int cheia(pilha p) {
  return tamanho(p) == p.capacidade; 
}

/*------------------------------------------------------------------*/
pilha *cria_pilha(pilha *p) {

  if ( !p ) return NULL;

  p->ultimo = (p->primeiro = malloc(sizeof(float))) - 1;

  if ( !p->primeiro ) return NULL;

  p->capacidade = 1;

  return p;
}

/*------------------------------------------------------------------*/
pilha *destroi_pilha(pilha *p) {

  free(p->primeiro);
  p->capacidade = 0;
  p->ultimo = (p->primeiro = NULL) - 1;
  
  return p;
}

/*------------------------------------------------------------------*/
int empilha(float o, pilha *p) {
  if ( cheia(*p) ) {

    float *vetor_aumentado = realloc(p->primeiro,
                                     2*p->capacidade*sizeof(float)
                                     );

    if ( ! vetor_aumentado ) return 0;
    
    p->primeiro = vetor_aumentado;
    p->capacidade *= 2;
  }

  *(++p->ultimo) = o;

  return 1;
}

/*------------------------------------------------------------------*/
int desempilha(float *o, pilha *p) {

  if ( p->ultimo < p->primeiro ) return 0;

  *o = *(p->ultimo--);

  return 1;
}

/*----------------------------------------------------------------------------*/
void escreve_pilha(pilha l) {

  float *p;

  printf("%p,%d/%d: ", l.primeiro, tamanho(l), l.capacidade);

  for ( p=l.primeiro; p<l.ultimo; ++p ) {
    printf("%.3f", *p);
    printf(" ");
  }

  if ( p == l.ultimo )     printf(" %.3f", *p);
}
